function [m,list] = assignmatch(m,varargin)
%
% ASSIGNMATCH  Assign model parameters and/or steady state matching names with regular expressions.
%
% [m,list] = assignmatch(m,<expr,value>)
% Arguments:
%   m model, list cellstr, expr char, value numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

nalt = size(m.assign,3);

list = [];
invalid = {};
for i = 1 : 2 : length(varargin)
  match = regexp(m.name,sprintf('^%s$',varargin{i}),'match');
  try index = find(~cellfun(@isempty,match));
    catch index = find(~cellfun('isempty',match)); end  
  if isempty(index), continue, end
  list = [list,index];
  value_(varargin{i+1},index);
end

if ~isempty(invalid), error_(46,unique(invalid)); end
if nargout > 1, list = m.name(list); end

  function value_(value,index) % nested function ------------------------------------------------------------

  value = permute(value(:),[3,2,1]);
  if length(value) == nalt, value = value(1,ones([1,length(index)]),:);
    elseif length(value) == 1, value = value(1,ones([1,length(index)]),ones([1,nalt]));
    else invalid(end+(1:length(index))) = m.name(index); end
  m.assign(1,index,:) = value;

  end % of nested function ----------------------------------------------------------------------------------

end % of primary function -----------------------------------------------------------------------------------