function eigval = eig(m,alt)
%
% EIG  Model eigenvalues sorted in ascending order of moduli.
%
% Syntax:
%   e = eig(m,alt)
% Arguments:
%   e numeric; m model; alt numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if isempty(m.solution{1}), error_(12); end
if nargin < 2, alt = 1 : size(m.assign,3);
  else alt = vech(alt); end

eigval = m.eigval(1,:,alt);

end % of primary function ----------------------------------------------------------------------------------