function flag = isstationary(m)
%
% ISSTATIONARY  True if there are no unit roots in model transition matrix.
%
% flag = isstationary(m)
% Arguments:
%   flag logical; m model
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if isempty(m.solution{1}),
  flag = NaN;
else
  nb = size(m.solution{1},2);
  realsmall = getrealsmall();
  flag = permute(all(abs(m.eigval(1,1:nb,:)) < 1-realsmall,2),[1,3,2]);
end

end % of primary function -----------------------------------------------------------------------------------