function [mloglik,se2,pred,smooth] = kalmanf(m,data,varargin)
%
% KALMANF  Kalman filter.
%
% Syntax:
%   [mloglik,se2,pred,smooth] = kalmanf(m,data,...)
% Arguments:
%   mloglik numeric; se2 numeric; pred struct; smooth struct; m model; data cell|numeric
% Options:
%   'exclude' cellstr (empty) List of measurement variables to be excluded from the likelihood function.
%   'relative' logical (true) If true MSE matrices are scaled by estimated variance factor
%
% See also MODEL/LOGLIK, MODEL/MAXLOGLIK.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

% deterministic regressors
if nargin > 2 && isnumeric(varargin{1})
  Z = varargin{1};
  varargin(1) = [];
else
  Z = [];
end

[mloglik,se2,F,pe,A,Pa,setup,pred,smooth] = loglik(m,data,Z,{},varargin{:});

end % of primary function -----------------------------------------------------------------------------------