function error_(code,list,varargin)

switch code

case 0
  msg = ['No block of transition variables and/or equations; ',varargin{1},' may not be a model code file.'];

case 1
  msg = 'Unable to parse following segment of code: %s.';
  
case 2
  msg = sprintf('Invalid name in %s: ''%%s''.',upper(varargin{1}));

case 3
  msg = sprintf('Multiple declaration of name in %s: ''%%s''.',upper(varargin{1}));

case 4
  msg = sprintf('Invalid name in log declaration block in %s: ''%%s''.',upper(varargin{1}));

case 6
  msg = sprintf('Invalid model structure in %s. %s',upper(varargin{2}),varargin{1});

case 7
  msg = 'NaN or Inf occured in: %s.';

case 8
  msg = sprintf('Syntax error in %s: %%s\\n\\t%%s',upper(varargin{1}));
  
case 9
  msg = 'Unable to evaluate time subscript(s) in: %s';
  
case 12
  msg = 'Model solution not available. Use SOLVE first.';
  
case 16
  msg = 'Unmatched curly braces in: %s';

case 25
  msg = 'Initial condition not available from source data: %s.';

case 26
  msg = 'Exogenised data point(s) not available from source data: %s.';
  
case 30
  msg = 'No equation found with label: ''%s''.';  
  
case 32
  msg = 'Model variables need to be stationary or difference-stationary when using SSTATE.';

case 33
  msg = 'Simulatenous use of anticipated and unanticipated anchors not implemented.';
  
case 34
  msg = 'Plan range and simulation range must agree.';

case 35
  msg = sprintf('Invalid keyword or function in %s: ''%%s''.',upper(varargin{1}));

case 37
  msg = 'Multiple equal signs in equation: %s';

case 38
  msg = sprintf('Undeclared or mistyped name in %s: ''%%s'' in equation %%s',upper(varargin{1}));

case 39
  msg = 'NaN steady state value for variable: ''%s''. Unable to simulate.';

case 40
  msg = 'Model code file contains character(s) beyond char(255): %s.';

case 41
  msg = 'Incorrect specification of @ar process: @ar(%s).';

case 42
  msg = 'Source datapack range and simulation range must agree.';

case 43
  msg = 'Fixed steady state not available: %s.';

case 44
  msg = 'Number of alternative databases/datapacks and number of alternative parameterisations must match.';

case 46
  msg = 'Incorrect number of alternative parameterisations/steady states/time series: %s.';

case 47
  msg = 'Unable to run MODEL/%s with multiple parameterisations or multiple data variants.';

case 48
  msg = 'Number of alternative parameterisations must remain higher than 0.';

case 49
  msg = 'Invalid measurement or transition name in the map of tunes: %s.';

case 50
  msg = 'Invalid residual name in the map of tunes: %s.';

case 51
  msg = 'Incompatible settings of options:%s.';

case 52
  msg = 'Indicator ''@allbut'' must appear in all or none of log declaration blocks.';

case 53
  msg = 'No parameters to be optimised.';

end
  
if nargin == 1
  list = {};
end

printmsg('model','error',msg,list,code);

end