function m = nalt_(m,n)
%
% MODEL/PRIVATE/NALT_  Change number of alternative parameterizations.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

n = round(n);
if n <= 0, error_(48); end

nalt0 = size(m.assign,3);
if n > nalt0
  index = nalt0+1:n;
  repeat = nalt0*ones([1,n-nalt0]);
  m.assign(1,:,index) = m.assign(1,:,repeat);
  if ~isempty(m.solution{1})
    for i = 1 : length(m.solution), m.solution{i}(:,:,index) = m.solution{i}(:,:,repeat); end
    for i = 1 : length(m.expand), m.expand{i}(:,:,index) = m.expand{i}(:,:,repeat); end
     m.eigval(1,:,index) = m.eigval(1,:,repeat);
  end
elseif n < nalt0
  m.assign = m.assign(1,:,1:n);
  if ~isempty(m.solution{1})
    for i = 1 : length(m.solution), m.solution{i} = m.solution{i}(:,:,1:n); end
    for i = 1 : length(m.expand), m.expand{i} = m.expand{i}(:,:,1:n); end
  end
  m.eigval = m.eigval(1,:,1:n);
end

end % of primary function -----------------------------------------------------------------------------------