function [T,R,K,Z,H,D,Za,Omega] = sspace_(m,alt)
%
% MODEL/PRIVATE/SSPACE_  General state-space form without forward expansion.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

[ny,nx,nf,nb,ne,np,nalt] = dim_(m);
if nargin < 2, alt = 1 : nalt;
  else alt = vech(alt); end

T = m.solution{1}(:,:,alt);
R = m.solution{2}(:,1:ne,alt); % no forward expansion
K = m.solution{3}(:,:,alt);
Z = m.solution{4}(:,:,alt);
H = m.solution{5}(:,:,alt);
D = m.solution{6}(:,:,alt);
Za = m.solution{7}(:,:,alt);

if isempty(Z), Z = zeros([0,nb,length(alt)]); end
if isempty(H), H = zeros([0,ne,length(alt)]); end
if isempty(D), D = zeros([0,1,length(alt)]); end

if nargout > 7, Omega = omega_(m,alt); end

end % of primary function -----------------------------------------------------------------------------------