function X = trendarray_(m,id,tvec,delog,alt,precision)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin < 5, alt = inf; end
if nargin < 6, precision = m.precision; end

% function body ---------------------------------------------------------------------------------------------

if islogical(alt), alt = find(alt);
  elseif any(isinf(alt)), alt = 1 : size(m.assign,3); end

nper = length(tvec);
nid = length(id);
X = zeros([nid,nper,length(alt)],precision);

if nid == 0, return, end

assign = m.assign(1,:,alt);

log_ = m.log(real(id));
repeat = ones([1,nper]);
shift = vec(imag(id));
shift = shift(:,repeat);
shift = shift + tvec(ones([1,nid]),:);

for i = 1 : length(alt)
  level = real(assign(1,real(id),i));
  growth = imag(assign(1,real(id),i));

  % no imaginary part: zero growth for log variables 
  growth(log_ & growth == 0) = 1;

  level(log_) = log(level(log_));
  growth(log_) = log(growth(log_));
  level = transpose(level);
  growth = transpose(growth);
  x = level(:,repeat) + shift.*growth(:,repeat);
  if delog == true, x(log_,:) = exp(x(log_,:)); end

  X(:,:,i) = x;
end

end % of primary function -----------------------------------------------------------------------------------