function m = reset(m,defaultstd)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

% pre-allocate deriv0 matrices 
nshift = size(m.occur,3);
nvar = sum(m.nametype <= 3);
nderiv = nshift*nvar;
neqtn = sum(m.eqtntype <= 2);
m.deriv0.c = zeros([neqtn,1],m.precision);
m.deriv0.f = sparse(zeros([neqtn,nderiv]));

% pre-allocate system0 matrices 
try, ntilde = cellfun(@length,m.systemid);
catch, ntilde = cellfun('length',m.systemid); end
nf = sum(double(imag(m.systemid{2}) >= 0));
nb = ntilde(2) - nf;
m.system0.K{1} = zeros([ntilde(1),1],m.precision);
m.system0.K{2} = zeros([ntilde(2),1],m.precision);
m.system0.A{1} = sparse(zeros([ntilde(1),ntilde(1)]));
m.system0.B{1} = sparse(zeros([ntilde(1),nb]));
m.system0.E{1} = sparse(zeros([ntilde(1),ntilde(3)]));
m.system0.A{2} = sparse(zeros([ntilde(2),ntilde(2)]));
m.system0.B{2} = sparse(zeros([ntilde(2),ntilde(2)]));
m.system0.E{2} = sparse(zeros([ntilde(2),ntilde(3)]));

% pre-allocate assign vectors
m.assign = nan([1,length(m.name)]);
m.assign(m.nametype == 3) = 0;
m.assign(end-sum(m.nametype == 3)+1:end) = defaultstd;
m.assign0 = m.assign;

end % of primary function -----------------------------------------------------------------------------------