function varargout = sspace(m,alt)
%
% SSPACE  Quasi-triangular state-space form of model.
%
% Syntax:
%   [T,R,K,Z,H,D,U,Omega,list] = sspace(m)
% Arguments:
%   T,R,K,Z,H,D,U,Omega numeric; list cell; m model
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

nalt = size(m.solution{1},3);
if isempty(m.solution{1}), error_(12); end 
if nargin < 2, alt = 1 : nalt;
  else alt = vech(alt); end

[varargout{1:8}] = sspace_(m,alt);
ny = size(varargout{4},1);
nx = size(varargout{1},1);
if nargout == 2 || nargout > 8
  tmp = printid_(m);
  list = {tmp(1:ny),tmp(ny+(1:nx)),tmp(ny+nx+1:end)};
end

if nargout <= 2,
  warning('iris:obsolete','No conversion of model to sspace necessary any longer.');
  varargout{1} = m;
  if nargout == 2, varargout{2} = list; end
else
  if nargout > 8, varargout{9} = list; end
end

end % of primary function -----------------------------------------------------------------------------------