function [A,B,K,E,list,nf] = system(m)

% xf unpredetermined transition variables
% xb predetermined transition variables
% y measurement variables
% e residuals

% A{1} y + B{1} xb + K{1} + E{1} e = 0
% A{2} E_t [xf;xb] + B{2} [xf-;xb-] + K{2} + E{2} e = 0

nalt = size(m.assign,3);

for ialt = 1 : nalt
  eqselect = eqselect_(m,ialt);
  [m,deriv] = deriv_(m,eqselect,ialt);
  [m,sys] = system_(m,deriv,eqselect,ialt);
  A{1}(:,:,ialt) = full(sys.A{1});
  B{1}(:,:,ialt) = full(sys.B{1});
  K{1}(:,1,ialt) = full(sys.K{1});
  E{1}(:,:,ialt) = full(sys.E{1});
  A{2}(:,:,ialt) = full(sys.A{2});
  B{2}(:,:,ialt) = full(sys.B{2});
  K{2}(:,1,ialt) = full(sys.K{2});
  E{2}(:,:,ialt) = full(sys.E{2});
end

list{1} = printid(m.name(real(m.systemid{1})),imag(m.systemid{1}),m.log(real(m.systemid{1})));
list{2} = printid(m.name(real(m.systemid{2})),imag(m.systemid{2}) + 1,m.log(real(m.systemid{2})));
list{3} = printid(m.name(real(m.systemid{3})),imag(m.systemid{3}),m.log(real(m.systemid{3})));
nf = sum(imag(m.systemid{2}) >= 0);

end