function [w,dpack] = demean(w,dpack)
%
% DEMEAN  Remove mean (constant) from VAR and its datapack.
%
% Syntax:
%   [w,dpack] = demean(w,dpack)
%  Arguments:
%   w rvar|svar; dpack cell
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

index = isstationary(w);

for iloop = find(index)
  if nargin > 1 && nargout > 1
    % detrend datapack
    nper = length(dpack{4});
    ymean = mean(w,iloop);
    dpack{1}(:,:,iloop) = dpack{1}(:,:,iloop) - ymean(:,ones([1,nper]));
  end
  % remove constant from VAR
  w.K(:,1,iloop) = 0;
end

if any(~index), warning_(8,{sprintf(' %s',find(~index))}); end

end % of primary function -----------------------------------------------------------------------------------