function error_(code,list,varargin)

switch code

case 1
  msg = 'Error when evaluating parameter constraints: %s';
  
case 2
  msg = 'LR-tested VAR models need to be estimated on identical samples.';

case 3
  msg = 'Time series for following variable(s) not available:';
  
case 7
  msg = 'Insufficient data to simulate.';

case 8
  msg = 'Portmonteau test order need to exceed VAR order.';  
  
case 9
  msg = 'Time series disrupted by within-sample NaNs.';
  
case 10
  msg = 'Insufficient number of observations.';  
    
case 11
  msg = '%s does not accept multiple parameterizations.';

case 12
  msg = 'Unable to reverse structural VAR.';

case 13
  msg = 'Unable to compute FEVD for reduced-form VAR.';

case 14
  msg = 'Invalid ordering vector.';

case 15
  msg = 'Unable to print reduced-form VAR as model code.';

case 16
  msg = 'Unable to compute shock response function for reduced-form VAR.';

end

if nargin == 1, list = {}; end

printmsg('VAR','error',msg,list,code);

end