function x = comment(x,cmt)
%
% COMMENT  Set or get time series comment.
%
% Syntax:
%   cmt = comment(x)
%   x = comment(x,cmt)
% Arguments:
%   cmt char; x tseries
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin > 1 && ~ischar(cmt) && ~iscellstr(cmt), error('Incorrect type of input argument(s).'); end

% function body ---------------------------------------------------------------------------------------------

dim = size(x);
if nargin < 2
  if all(dim(2:end) == 1), x = x.comment{1};
    else x = x.comment; end
else
  aux = cmt;
  cmt = strrep(cmt,'"','');
  if ischar(cmt), x.comment(:) = {cmt};
    else x.comment(:) = cmt(:); end
end

end % of primary function -----------------------------------------------------------------------------------