function display(x)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

% print object class and size
if ~isempty(inputname(1)), disp([char(10),inputname(1),' =']); end
dim = size(x.data);
nper = dim(1);
disp(sprintf('\n\ttseries object: %g%s\n',nper,sprintf('-by-%g',dim(2:end))));

% print dates
if nper > 0
  chars = @(x,n) x(ones([1,n]),1:length(x));
  dates = [chars(sprintf('\t'),nper),dat2char(x.start:x.start+nper-1),chars(sprintf(': '),nper)];
  dispplane_(x.data,x.comment,dates,inputname(1),[]);
end

end % of primary function -----------------------------------------------------------------------------------

  function dispplane_(data,cmt,dates,name,position) % subfunction -----------------------------------------------
  dim = size(data);
  ndim = length(dim);
  if length(dim) > 2
    subs(1:ndim) = {':'};
    for i = 1 : dim(end)
      subs(end) = {i};
      dispplane_(subsref(data,struct('type','()','subs',{subs})),...
        subsref(cmt,struct('type','()','subs',{[{1},subs(2:end)]})),dates,name,[i,position]);
    end
  else
    if ~isempty(position), disp(sprintf('%s(:,:%s) =\n',name,sprintf(',%g',position))); end
    disp([dates,num2str(data)]);
    disp(' ');
    disp(cmt);
  end
  end % of subfunction --------------------------------------------------------------------------------------