function x = mm2zz(x,range,varargin)
%
% MM2ZZ  Monthly to semi-annual time series conversion.
%
% x = mm2zz(x)
% x = mm2zz(x,range,...)
% Arguments:
%   x tseries; rng numeric
% Options:
%   'function' function_handle|char (@mean)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if (nargin > 1 && ~isnumeric(range)) || (nargin > 2 && ~iscellstr(varargin(1:2:end))), error('Incorrect type of input argument(s).'); end

default = {
  'function',@mean,...
};
options = passopt(default,varargin{1:end});

if nargin < 2, range = Inf;
  else range = setrange(range); end

% function body ---------------------------------------------------------------------------------------------

x = freq2freq_(x,range,12,2,options.function);

end % of primary function -----------------------------------------------------------------------------------