function x = normalise(x,normdate,varargin)
%
% NORMALISE  Normalise data to particular date.
%
% Syntax:
%   x = normalise(x)
%   x = normalise(x,normdate,...)
% Arguments:
%   x numeric; normdate numeric|char
% Options:
%   'mode' char ('mult')
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

default = {
  'mode','mult',...
};
options = passopt(default,varargin{:});

if nargin == 1, normdate = 'start'; end

% function body ---------------------------------------------------------------------------------------------

fn = iff(strcmp(options.mode,'add'),@minus,@rdivide);

if strcmp(normdate,'start'), normdate = max(get(x,'start'));
  elseif strcmp(normdate,'end'), normdate = min(get(x,'end')); end

[x.data,dim] = reshape_(x.data);
y = getdata_(x,normdate);
for i = 1 : size(x.data,2), x.data(:,i) = fn(x.data(:,i),y(i)); end
x.data = reshape_(x.data,dim);

end % of primary function -----------------------------------------------------------------------------------