function x = cut_(x)
%
% TSERIES/PRIVATE/CUT_  Remove leading and trailing NaNs.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[x.data,dim] = reshape_(x.data);
index = any(~isnan(x.data),2);
if any(index)
  from = find(index,1);
  to = find(index,1,'last');
  x.start = x.start + from - 1;
  index = from : to;
else
  x.start = NaN;
  index = [];
end
x.data = reshape_(x.data(index,:),dim);

end % of primary function -----------------------------------------------------------------------------------