function subs = indexing_(subs,start,dim)

% colon-indexing in dates
if strcmp(subs{1},':')
  if isnan(start), subs{1} = zeros([0,1]);
    else, subs{1} = start : start+dim(1)-1; end
end

if length(subs) == 1
  % only dates specified
  for i = 2 : length(dim), subs{i} = 1 : dim(i); end
else
  % colon-indexing
  for i = 2 : length(subs)
    if strcmp(subs{i},':')
      try, subs{i} = 1 : dim(i);
        % higher singleton dimensions set to 1
        catch, subs{i} = 1; end
    end
  end
end

end