function x = setdata_(x,dates,data,varargin)

xsize = size(x.data);
xsize = xsize(2:end);
if sum(xsize > 1) == 0 && sum(size(data) > 1) <= 1, data = vec(data); end

if nargin > 3, subs = [{''},varargin];
  else subs = indexing_({[]},[],size(x.data)); end

dates = dates(:);
xfinish = x.start + size(x.data,1) - 1;
if any(isinf(dates))
  dates = x.start : xfinish;
end

nper = length(dates);
nobs = size(data,1);

if nper == 0 && size(data,1) == 0, return, end  

% assigning to an empty time series
if isnan(x.start)
  [x.start,x.data] = init_(dates,data);
  return
end

% exclude NaN dates and incorrect frequencies
index = abs((dates-floor(dates)) - (x.start-floor(x.start))) < 0.01 & ~isnan(dates);
dates(~index) = [];
[data,dim] = reshape_(data);
data(~index,:) = [];
data = reshape_(data,dim);

dim = size(x.data);
nper = dim(1);
dim = dim(2:end);
index = round(dates - x.start + 1);
if any(index > nper)
  x.data = [x.data;nan([max(index)-nper,dim])];
end
if any(index < 1)
  minindex = min(index);
  x.data = [nan([1-minindex,dim]);x.data];
  x.start = x.start - 1 + minindex;
  index = index + 1 - minindex;
end

x.data(index,subs{2:end}) = data;

end