function x = set(x,varargin)
%
% SET  Set time series attributes.
%
% x = set(x,<attrib,value>)
% Arguments:
%   x tseries, attrib char, value depends on attrib
% Attributes:
%   'comment' char
%   'freq' numeric
%   'end' numeric
%   'range' numeric
%   'start' numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if ~iscellstr(varargin(1:2:end)), error('Incorrect type of input argument(s).'); end

% functio body ----------------------------------------------------------------------------------------------

invalid = cell([1,0]);
for i = 1 : 2 : nargin-1
  if set_(varargin{i},varargin{i+1}) == false, invalid{end+1} = varargin{i}; end
end

if ~isempty(invalid), warning(sprintf('Unrecognised attribute: ''%s''. ',invalid{:})); end

  function valid = set_(attribute,value) % nested function --------------------------------------------------

  attribute(isspace(attribute)) = '';
  attribute = lower(attribute);
    
  valid = true;
  switch attribute
  case {'start','startdate','first'}
    x.start = value;
  case {'end','enddate','last'}
    x.start = value - size(x.data,1) + 1;
  case 'comment'
    x = comment(x,value);
  otherwise
    valid = false;
  end % of switch
  
  end % of nested function ----------------------------------------------------------------------------------
  
end % end of primary function -------------------------------------------------------------------------------