function x = subsref(x,s)
%
% TSERIES/SUBSREF  Subscripted reference.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

% x{}
if strcmp(s(1).type,'{}')
  if length(s(1).subs) ~= 1 || length(s(1).subs{1}) ~= 1, error_(); end
  for i = 1 : length(x)
    x(i).start = x(i).start - s(1).subs{1};
  end
  s(1) = [];
end

% x()
if ~isempty(s) && strcmp(s(1).type,'()')
  % check for 'tseries' flag
  if ~isempty(s(1).subs) && strcmp(s(1).subs{end},'tseries'), flag = true; s(1).subs(end) = [];
    else flag = false; end
  s(1).subs = indexing_(s(1).subs,x.start,size(x.data));
  if flag == true
    % x(dates,index,...,'tseries')
    [x.data,dates] = getdata_(x,s(1).subs{1},s(1).subs{2:end});
    if isempty(dates), x.start = NaN;
      else, x.start = dates(1); end
    x.comment = x.comment(1,s(1).subs{2:end});
  else
    % x(dates,index,...)
    x = getdata_(x,s(1).subs{1},s(1).subs{2:end});
  end
  s(1) = [];
end

% x.comment
if ~isempty(s) && strcmp(s(1).type,'.') && strcmp(lower(s(1).subs),'comment')
  if length(x) == 1, x = x.comment;
    else x = {x(:).comment}; end
  s(1) = [];
end
  
if ~isempty(s), error('Incorrect time series indexing.'); end

end % of primary function -----------------------------------------------------------------------------------