function s = datstr(year,per,freq,dateformat,freqletters)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if freq == 0
  varyear = '';
  longyear = '';
  shortyear = '';
else
  varyear = sprintf('%g',year);
  longyear = sprintf('%04g',year);
  if length(longyear) > 2, shortyear = longyear(end-1:end);
    else, shortyear = longyear; end
end

save = {'{Y}','{P}','{F}','{f}','{R}','{M}','{m}'};
for i = 1 : length(save), dateformat = strrep(dateformat,save{i},char(i)); end

switch freq
case 0
  freqstring = '';
  arabper = sprintf('%g',per);
  [longmonth,shortmonth] = month_(13);
case 1
  freqstring = freqletters(1);
  arabper = '';
  [longmonth,shortmonth] = month_(13);
case 2
  freqstring = freqletters(2);
  arabper = sprintf('%g',per);
  [longmonth,shortmonth] = month_(13);
case 4
  freqstring = freqletters(3);
  arabper = sprintf('%g',per);
  [longmonth,shortmonth] = month_(13);
case 12
  freqstring = freqletters(4);
  arabper = sprintf('%02g',per);
  [longmonth,shortmonth] = month_(per);
otherwise
  freqstring = '?';
  arabper = sprintf('%g',per);
  [longmonth,shortmonth] = month_(13);
end
romanper = roman_(per);

s = dateformat;
s = strrep(s,'YYYY',longyear);
s = strrep(s,'YY',shortyear);
s = strrep(s,'Y',varyear);
s = strrep(s,'P',arabper);
s = strrep(s,'R',romanper);
s = strrep(s,'F',upper(freqstring));
s = strrep(s,'f',lower(freqstring));

s = strrep(s,'Mmmm',longmonth);
s = strrep(s,'Mmm',shortmonth);
s = strrep(s,'mmmm',lower(longmonth));
s = strrep(s,'mmm',lower(shortmonth));
s = strrep(s,'MMMM',upper(longmonth));
s = strrep(s,'MMM',upper(shortmonth));

for i = 1 : length(save), s = strrep(s,char(i),save{i}(2)); end

end % of primary function -----------------------------------------------------------------------------------

  function r = roman_(x) % subfunction ----------------------------------------------------------------------

  switch x
    case 1, r = 'I';
    case 2, r = 'II';
    case 3, r = 'III';
    case 4, r = 'IV';
    case 5, r = 'V';
    case 6, r = 'VI';
    case 7, r = 'VII';
    case 8, r = 'VIII';
    case 9, r = 'IX';
    case 10, r = 'X';
    case 11, r = 'XI';
    case 12, r = 'XII';
    otherwise, r = '';
  end

  end % of subfunction --------------------------------------------------------------------------------------

  function [longmonth,shortmonth] = month_(m) % subfunction -------------------------------------------------

  switch m
    case 1, longmonth = 'January';
    case 2, longmonth = 'February';
    case 3, longmonth = 'March';
    case 4, longmonth = 'April';
    case 5, longmonth = 'May';
    case 6, longmonth = 'June';
    case 7, longmonth = 'July';
    case 8, longmonth = 'August';
    case 9, longmonth = 'September';
    case 10, longmonth = 'October';
    case 11, longmonth = 'November';
    case 12, longmonth = 'December';
    otherwise, longmonth = '???';
  end

  shortmonth = longmonth(1:3);

  end % of subfunction --------------------------------------------------------------------------------------