function s = dbevals(d,s,varargin)
%
% DBEVALS  Evaluate and replace expressions within string.
%
% Syntax:
%   s = dbevals(d,s,...)
% Arguments
%   s char; d dbase|struct
% Options:
%   'format' char ('%g')
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

default = {...
  'numericformat','%g',...
  'textformat','%s',...
};
options = passopt(default,varargin{:});

% function body ---------------------------------------------------------------------------------------------

[match,tokens] = regexp(s,'@\{(.*?)(,.*?)?@\}','match','tokens');
tokens = [tokens{:}];
express = tokens(1:2:end);
format = tokens(2:2:end);
format = strrep(format,',','');
format(cellfun(@isempty,format) & cellfun(@isnumeric,format)) = {options.numericformat};
format(cellfun(@isempty,format) & cellfun(@ischar,format)) = {options.textformat};
x = cell(size(express));
[x{:}] = dbeval(d,express{:});
for i = 1 : length(x)
  s = strrep(s,match{i},sprintf(format{i},x{i}));
end

end % of primary function -----------------------------------------------------------------------------------