function list = dbobjects(d,classfilter)
%
% DBOJBECTS  List of database fields of given class.
%
% Syntax:
%   list = dbobjects(d,classfilter)
% Arguments:
%   list cellstr; d struct; classfilter char
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin < 2, classfilter = 'tseries'; end

% function body ---------------------------------------------------------------------------------------------

if ~isstruct(d), list = {}; return, end

list = fieldnames(d);
if strcmp(classfilter,'float'), index = cellfun('isclass',struct2cell(d),'double') | cellfun('isclass',struct2cell(d),'single');
  else, index = cellfun('isclass',struct2cell(d),classfilter); end
list = vech(list(index));

end % of primary function -----------------------------------------------------------------------------------