function [d,list] = dbremove(d,varargin)
%
% DBREMOVE  Remove fields from database.
%
% Syntax:
%   [d,list] = dbremove(d,...)
% Arguments:
%   d struct; list cellstr
% Options:
%   'namefilter' char|cellstr|Inf (Inf)
%   'classfilter' char|cellstr|Inf (Inf)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if ~isstruct(d), error('Incorrect type of input argument(s).'); end  

% function body ---------------------------------------------------------------------------------------------

list = dbquery(d,'','',varargin{:});
d = rmfield(d,list);

end % of primary function -----------------------------------------------------------------------------------