function coher = xs2coher(xs)
%
% XS2COHER  Cross-spectrum to coherence conversion.
%
% Syntax:
%   coher = xs2coher(xs)
% Arguments:
%   coher numeric; xs cell
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

amplitude2 = real(xs{1}).^2 + imag(xs{1}).^2;
coher = zeros(size(xs{1}));
realsmall = getrealsmall();

for i = 1 : size(xs{1},3)
%  warning('off','MATLAB:divideByZero');
    d = diag(xs{1}(:,:,i));
    index = abs(d) <= realsmall;
    d(~index) = 1./d(~index);
    d(index) = 0;
    D = diag(d);
    coher(:,:,i) = D * amplitude2(:,:,i) * D;
%  warning('on','MATLAB:divideByZero');
end

for i = 1 : size(xs{1},1), coher(i,i,:) = 1; end
coher = {coher,xs{2}};

end % of function body --------------------------------------------------------------------------------------