function A = poly2var(A)
%
% POLY2VAR  Polynomial to VAR conversion.
%
% Syntax:
%   A = var2poly(P)
% Arguments:
%   A numeric; P numeric
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,ny,p,nalt] = size(A);
p = p - 1;
for ialt = 1 : nalt
  if any(A(:,:,1,ialt) ~= eye(ny))
    error('Polynomial must be monic.');
  end
end
A = reshape(-A(:,:,2:end,:),[ny,ny*p,nalt]);

end % of primary function -----------------------------------------------------------------------------------