function [M,Phi] = fmse(T,R,K,Z,H,D,Za,Omega,nper)
%
% TIME-DOMAIN/FMSE  General state-space forecast mean square error matrix.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

ny = size(Z,1);
[nx,nb] = size(T);
nf = nx - nb;
ne = size(R,2);
n = ny + nf + nb;

Phi = srf(T,R,K,Z,H,D,Za,Omega,nper);
M = zeros([n,n,nper]);
for i = 1 : nper
  M(:,:,i) = Phi(:,:,i)*Omega*transpose(Phi(:,:,i));
end
M = cumsum(M,3);

end % of primary function -----------------------------------------------------------------------------------