function D = stackcov(C,mode)
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% ascend: [C1,C2',C3';C2,C1,C2';C3,C2,C1]
% descend: [C1,C2,C3;C2',C1,C2;C3',C2',C1]

if nargin < 2, mode = 'ascend'; end

% function body ---------------------------------------------------------------------------------------------

[ny,ny,k] = size(C);
Cprime = permute(C,[2,1,3]);
switch lower(mode)
case 'ascend'
  aux = [reshape(C(:,:,end:-1:1),[ny,k*ny]),reshape(Cprime(:,:,2:end),[ny,ny*(k-1)])];
case 'descend'
  aux = [reshape(Cprime(:,:,end:-1:2),[ny,(k-1)*ny]),reshape(C(:,:,1:end),[ny,ny*k])];
end

D = zeros(ny*k);
index = false([1,ny*(2*k-1)]);
index(end-((ny*k):-1:1)+1) = true;
for i = 1 : k
  D((i-1)*ny+(1:ny),:) = aux(:,index);
  index = [index(ny+1:end),false([1,ny])];
end

end % of primary function -----------------------------------------------------------------------------------