function [y0,y1,k0,g1] = stackdata(y,p,constant,cointeg)
%
% TIME-FREQ/STACKDATA  Stack data for estimation of VAR.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

[ny,nper,nalt] = size(y);
nper = nper - p;
y0 = y(:,1+p:end,:);
y1 = zeros([0,nper,nalt]);
for i = 1 : p, y1 = [y1;y(1:end,1+p-i:end-i,:)]; end
% cointegrating vector
if nargin > 3 && nargout > 3
  if isempty(cointeg)
    g1 = zeros([0,nper,nalt]);
  else
    nper = nper - 1;
    g1 = [];
    for ialt = 1 : nalt, g1(:,:,ialt) = transpose(cointeg)*[y0(:,1:end-1,ialt);ones([1,nper])]; end
    y0 = y0(:,2:end,:) - y0(:,1:end-1,:);
    y1 = y1(:,2:end,:) - y1(:,1:end-1,:);
  end
end
% constant
if nargin > 2 && nargout > 2
  nk = double(constant);
  k0 = ones([nk,nper]);
end

end % of primary function -----------------------------------------------------------------------------------