function [y,range] = getdata(varargin)
%
% UTILS/GETDATA  Get numeric data from different types of input arguments.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if isnumeric(varargin{1})
  % array
  y = permute(varargin{1},[2,1,3]);
  range = 1 : size(y,2);
elseif istseries(varargin{1})
  % tseries
  ny = size(varargin{2},2);
  if nargin < 2 || any(isinf(varargin{2})), range = 'min';
    else, range = varargin{2}(1):varargin{2}(end); end  
  [y,range] = double(varargin{1},range);
  y = permute(y,[2,1,3]);
elseif isstruct(varargin{1})
  % dbase
  if nargin < 3 || any(isinf(varargin{3})), range = 'min';
    else, range = varargin{3}(1):varargin{3}(end); end
  y = tseries([],[]);
  for i = 1 : length(varargin{2})
    y = [y,varargin{1}.(varargin{2}{i})];
  end
  [y,range] = double(y,range);
  y = permute(y,[2,1,3]);
elseif iscell(varargin{1})
  % dpack
  y = varargin{1};
  range = varargin{4};
end
  
end % of primary function -----------------------------------------------------------------------------------