function x = printid(name,shift,log)
%
% PRINTID  Write formatted identifiers.
%
% x = printid(name,shift,log)
% Arguments:
%   x cellstr, name cellstr, shift numeric, log logical
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

if nargin < 2, shift = zeros(size(name)); end
if nargin < 3, log = false(size(name)); end

% function body ---------------------------------------------------------------------------------------------

x = {};
for i = 1 : length(name)
  x{end+1} = sprintf(iff(log(i) == true,'log(%s%s)','%s%s'),name{i},iff(shift(i) ~= 0,sprintf('{%g}',shift(i)),''));
end

end % of primary function -----------------------------------------------------------------------------------