function printmsg(class,type,msg,list,code)
%
% UTILS/PRINTMSG  Print class error or warning messages.
%
% The IRIS Toolbox 2007/02/03. Copyright 2007 Jaromir Benes.

% function body ---------------------------------------------------------------------------------------------

if not(iscell(list)), list = {list}; end

switch type
case 'error'
  typestring = 'Error: ';
case 'warning'
  typestring = '';
end

irisstring = sprintf('%sThe IRIS Toolbox reference code %s:%02g.',typestring,upper(class),code);
body = sprintf(['\n==> ',msg],list{:});

if iswarning(class)
  disp(' ');
  if strcmp(type,'error');
    disp([irisstring,body]);
  else
    aux = warning('query','backtrace');
    warning('off','backtrace');
    warning(sprintf('iris:%s',class),[irisstring,body]);
    warning(aux.state,'backtrace');
  end
end

% issue error without using extra disp commands if warning iris:class is off
% this is to allow capturing errors by try-catch-end

if strcmp(type,'error')
  if iswarning(class)
    disp(' ');
    disp('Execution stopped, press any key to take control.');
    disp('Read the following message from the bottom up to locate the error in your files.');
    pause();
    error('IRIS %s.',typestring);
  else
    error([irisstring,body]);
  end
end

end % of primary function -----------------------------------------------------------------------------------